/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "style/mapcssparser.y"

/*
    SPDX-FileCopyrightText: 2020 Volker Krause <vkrause@kde.org>

    SPDX-License-Identifier: LGPL-2.0-or-later
*/

#include "mapcssparser_p.h"
#include "mapcssscanner.h"

#include "style/mapcssparser.h"
#include "style/mapcssrule_p.h"
#include "style/mapcssselector_p.h"
#include "style/mapcssstyle.h"

void yyerror(YYLTYPE *loc, KOSMIndoorMap::MapCSSParser *parser, yyscan_t scanner, char const* msg)
{
    (void)scanner;
    qWarning() << "PARSER ERROR:" << msg << "in" << parser->fileName() << "line:" << loc->first_line << "column:" << loc->first_column;
    parser->setError(QString::fromUtf8(msg), loc->first_line, loc->first_column);
}

using namespace KOSMIndoorMap;


#line 97 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "mapcssparser_p.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_LBRACKET = 3,                 /* T_LBRACKET  */
  YYSYMBOL_T_RBRACKET = 4,                 /* T_RBRACKET  */
  YYSYMBOL_T_LBRACE = 5,                   /* T_LBRACE  */
  YYSYMBOL_T_RBRACE = 6,                   /* T_RBRACE  */
  YYSYMBOL_T_LPAREN = 7,                   /* T_LPAREN  */
  YYSYMBOL_T_RPAREN = 8,                   /* T_RPAREN  */
  YYSYMBOL_T_COLON = 9,                    /* T_COLON  */
  YYSYMBOL_T_SEMICOLON = 10,               /* T_SEMICOLON  */
  YYSYMBOL_T_COMMA = 11,                   /* T_COMMA  */
  YYSYMBOL_T_SPACE = 12,                   /* T_SPACE  */
  YYSYMBOL_T_DASH = 13,                    /* T_DASH  */
  YYSYMBOL_T_PLUS = 14,                    /* T_PLUS  */
  YYSYMBOL_T_STAR = 15,                    /* T_STAR  */
  YYSYMBOL_T_ZOOM = 16,                    /* T_ZOOM  */
  YYSYMBOL_T_EXCLAMATION_MARK = 17,        /* T_EXCLAMATION_MARK  */
  YYSYMBOL_T_EQUALS = 18,                  /* T_EQUALS  */
  YYSYMBOL_T_DOT = 19,                     /* T_DOT  */
  YYSYMBOL_T_BINARY_OP = 20,               /* T_BINARY_OP  */
  YYSYMBOL_T_KEYWORD_IMPORT = 21,          /* T_KEYWORD_IMPORT  */
  YYSYMBOL_T_KEYWORD_URL = 22,             /* T_KEYWORD_URL  */
  YYSYMBOL_T_KEYWORD_RGBA = 23,            /* T_KEYWORD_RGBA  */
  YYSYMBOL_T_KEYWORD_RGB = 24,             /* T_KEYWORD_RGB  */
  YYSYMBOL_T_KEYWORD_SET = 25,             /* T_KEYWORD_SET  */
  YYSYMBOL_T_IDENT = 26,                   /* T_IDENT  */
  YYSYMBOL_T_HEX_COLOR = 27,               /* T_HEX_COLOR  */
  YYSYMBOL_T_STRING = 28,                  /* T_STRING  */
  YYSYMBOL_T_DOUBLE = 29,                  /* T_DOUBLE  */
  YYSYMBOL_YYACCEPT = 30,                  /* $accept  */
  YYSYMBOL_Ruleset = 31,                   /* Ruleset  */
  YYSYMBOL_Rule = 32,                      /* Rule  */
  YYSYMBOL_Import = 33,                    /* Import  */
  YYSYMBOL_Selectors = 34,                 /* Selectors  */
  YYSYMBOL_Selector = 35,                  /* Selector  */
  YYSYMBOL_BasicSelector = 36,             /* BasicSelector  */
  YYSYMBOL_ClassSelector = 37,             /* ClassSelector  */
  YYSYMBOL_ZoomRange = 38,                 /* ZoomRange  */
  YYSYMBOL_Tests = 39,                     /* Tests  */
  YYSYMBOL_Test = 40,                      /* Test  */
  YYSYMBOL_Condition = 41,                 /* Condition  */
  YYSYMBOL_BinaryOp = 42,                  /* BinaryOp  */
  YYSYMBOL_Key = 43,                       /* Key  */
  YYSYMBOL_Declarations = 44,              /* Declarations  */
  YYSYMBOL_Declaration = 45,               /* Declaration  */
  YYSYMBOL_PropertyName = 46,              /* PropertyName  */
  YYSYMBOL_PropertyValue = 47,             /* PropertyValue  */
  YYSYMBOL_DoubleValue = 48                /* DoubleValue  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  14
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   120

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  30
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  19
/* YYNRULES -- Number of rules.  */
#define YYNRULES  51
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  104

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   284


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   142,   142,   143,   147,   152,   156,   161,   165,   166,
     178,   179,   192,   199,   209,   210,   214,   215,   216,   217,
     218,   221,   222,   225,   229,   230,   231,   232,   236,   237,
     240,   241,   245,   246,   250,   251,   256,   261,   265,   272,
     273,   278,   279,   280,   281,   282,   283,   284,   293,   305,
     306,   307
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "T_LBRACKET",
  "T_RBRACKET", "T_LBRACE", "T_RBRACE", "T_LPAREN", "T_RPAREN", "T_COLON",
  "T_SEMICOLON", "T_COMMA", "T_SPACE", "T_DASH", "T_PLUS", "T_STAR",
  "T_ZOOM", "T_EXCLAMATION_MARK", "T_EQUALS", "T_DOT", "T_BINARY_OP",
  "T_KEYWORD_IMPORT", "T_KEYWORD_URL", "T_KEYWORD_RGBA", "T_KEYWORD_RGB",
  "T_KEYWORD_SET", "T_IDENT", "T_HEX_COLOR", "T_STRING", "T_DOUBLE",
  "$accept", "Ruleset", "Rule", "Import", "Selectors", "Selector",
  "BasicSelector", "ClassSelector", "ZoomRange", "Tests", "Test",
  "Condition", "BinaryOp", "Key", "Declarations", "Declaration",
  "PropertyName", "PropertyValue", "DoubleValue", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284
};
#endif

#define YYPACT_NINF (-17)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int8 yypact[] =
{
     -13,    24,   -16,    24,     0,   -17,   -17,    -1,   -10,   -17,
      -9,    25,    42,    25,   -17,   -17,   -17,   -10,   -17,   -17,
      -4,   -17,    26,   -17,    -3,   -10,    28,    37,    50,    47,
      50,   -17,   -12,    43,   -17,    49,   -17,    30,    21,   -17,
      18,    34,   -17,    27,    35,     6,   -17,    36,    59,    22,
     -17,    54,    55,    40,   -17,    23,   -17,    38,    39,    62,
      63,   -17,   -17,    60,    64,    65,    46,    64,   -17,   -17,
     -17,    -2,   -17,   -17,   -17,    66,    67,   -17,   -17,    45,
      51,    52,   -17,   -17,   -17,   -17,   -17,   -17,   -17,    68,
      71,   -17,    56,    57,    72,    73,    58,    61,    77,    70,
      69,   -17,    81,   -17
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       0,    14,     0,    14,     0,     2,     5,     0,     8,    10,
       0,    16,     0,    16,     1,     3,    32,     0,    11,    15,
       0,    21,     0,    21,     0,     9,     0,    19,    13,     0,
      12,     4,     0,    39,    33,     0,    20,    18,     0,    22,
       0,     0,    30,     0,     0,     0,    17,     0,     0,    27,
       6,     0,     0,     0,    37,     0,    40,     0,     0,     0,
       0,    42,    46,    49,    41,     0,    44,    26,    23,    29,
      28,     0,     7,    38,    31,     0,     0,    50,    51,     0,
       0,     0,    34,    43,    24,    49,    25,    35,    36,     0,
       0,    45,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    48,     0,    47
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -17,   -17,    87,   -17,   -17,    75,    -7,    90,    82,    74,
     -17,   -17,   -17,     1,   -17,   -17,    76,   -17,    29
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     4,     5,     6,     7,     8,     9,    11,    21,    28,
      39,    48,    71,    43,    24,    34,    35,    65,    66
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
      14,    18,     1,    31,    16,     1,    12,    41,     2,    26,
      17,    57,    58,     3,    42,     1,     3,    19,    18,    57,
      58,     2,    32,    33,    84,    27,     3,    85,    50,    59,
      60,    53,    42,    61,    62,    63,    53,    54,    47,    49,
      69,    20,    70,    10,    51,    55,    64,    42,    67,    22,
      37,    75,    76,    38,    29,    40,    44,    36,    45,    46,
      52,    33,    42,    68,    72,    73,    74,    77,    78,    79,
      80,    81,    83,    53,    89,    82,    87,    88,   101,    92,
      90,    91,    93,    96,    97,    94,    95,    98,   100,   103,
      99,    15,    25,    13,     0,    23,     0,    30,   102,     0,
      86,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      56
};

static const yytype_int8 yycheck[] =
{
       0,     8,    15,     6,     5,    15,    22,    19,    21,    13,
      11,    13,    14,    26,    26,    15,    26,    26,    25,    13,
      14,    21,    25,    26,    26,    29,    26,    29,    10,    23,
      24,     9,    26,    27,    28,    29,     9,    10,    17,    38,
      18,    16,    20,    19,    26,    18,    45,    26,    47,     7,
      13,    28,    29,     3,    28,     8,    13,    29,     9,    29,
      26,    26,    26,     4,    10,    10,    26,    29,    29,     7,
       7,    11,    26,     9,    29,    10,    10,    10,     8,    11,
      29,    29,    11,    11,    11,    29,    29,    29,    11,     8,
      29,     4,    17,     3,    -1,    13,    -1,    23,    29,    -1,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      44
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    15,    21,    26,    31,    32,    33,    34,    35,    36,
      19,    37,    22,    37,     0,    32,     5,    11,    36,    26,
      16,    38,     7,    38,    44,    35,    13,    29,    39,    28,
      39,     6,    25,    26,    45,    46,    29,    13,     3,    40,
       8,    19,    26,    43,    13,     9,    29,    17,    41,    43,
      10,    26,    26,     9,    10,    18,    46,    13,    14,    23,
      24,    27,    28,    29,    43,    47,    48,    43,     4,    18,
      20,    42,    10,    10,    26,    28,    29,    29,    29,     7,
       7,    11,    10,    26,    26,    29,    48,    10,    10,    29,
      29,    29,    11,    11,    29,    29,    11,    11,    29,    29,
      11,     8,    29,     8
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int8 yyr1[] =
{
       0,    30,    31,    31,    32,    32,    33,    33,    34,    34,
      35,    35,    36,    36,    37,    37,    38,    38,    38,    38,
      38,    39,    39,    40,    41,    41,    41,    41,    42,    42,
      43,    43,    44,    44,    45,    45,    45,    45,    45,    46,
      46,    47,    47,    47,    47,    47,    47,    47,    47,    48,
      48,    48
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     4,     1,     6,     7,     1,     3,
       1,     2,     4,     4,     0,     2,     0,     4,     3,     2,
       3,     0,     2,     3,     3,     3,     2,     1,     1,     1,
       1,     3,     0,     2,     4,     5,     5,     3,     4,     1,
       3,     1,     1,     2,     1,     3,     1,    10,     8,     1,
       2,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (&yylloc, parser, scanner, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location, parser, scanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, KOSMIndoorMap::MapCSSParser *parser, yyscan_t scanner)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  YYUSE (parser);
  YYUSE (scanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, KOSMIndoorMap::MapCSSParser *parser, yyscan_t scanner)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp, parser, scanner);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule, KOSMIndoorMap::MapCSSParser *parser, yyscan_t scanner)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]), parser, scanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, parser, scanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, KOSMIndoorMap::MapCSSParser *parser, yyscan_t scanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (parser);
  YYUSE (scanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_T_STRING: /* T_STRING  */
#line 129 "style/mapcssparser.y"
            { free(((*yyvaluep).str)); }
#line 1284 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
        break;

    case YYSYMBOL_Rule: /* Rule  */
#line 130 "style/mapcssparser.y"
            { delete ((*yyvaluep).rule); }
#line 1290 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
        break;

    case YYSYMBOL_Selectors: /* Selectors  */
#line 131 "style/mapcssparser.y"
            { delete ((*yyvaluep).selector); }
#line 1296 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
        break;

    case YYSYMBOL_Selector: /* Selector  */
#line 131 "style/mapcssparser.y"
            { delete ((*yyvaluep).selector); }
#line 1302 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
        break;

    case YYSYMBOL_Tests: /* Tests  */
#line 132 "style/mapcssparser.y"
            { delete ((*yyvaluep).conditionHolder); }
#line 1308 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
        break;

    case YYSYMBOL_Test: /* Test  */
#line 133 "style/mapcssparser.y"
            { delete ((*yyvaluep).condition); }
#line 1314 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
        break;

    case YYSYMBOL_Condition: /* Condition  */
#line 133 "style/mapcssparser.y"
            { delete ((*yyvaluep).condition); }
#line 1320 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
        break;

    case YYSYMBOL_Declarations: /* Declarations  */
#line 130 "style/mapcssparser.y"
            { delete ((*yyvaluep).rule); }
#line 1326 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
        break;

    case YYSYMBOL_Declaration: /* Declaration  */
#line 134 "style/mapcssparser.y"
            { delete ((*yyvaluep).declaration); }
#line 1332 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
        break;

    case YYSYMBOL_PropertyValue: /* PropertyValue  */
#line 134 "style/mapcssparser.y"
            { delete ((*yyvaluep).declaration); }
#line 1338 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (KOSMIndoorMap::MapCSSParser *parser, yyscan_t scanner)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, &yylloc, scanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* Ruleset: Ruleset Rule  */
#line 143 "style/mapcssparser.y"
               { Q_UNUSED((yyvsp[0].rule)); }
#line 1642 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 4: /* Rule: Selectors T_LBRACE Declarations T_RBRACE  */
#line 147 "style/mapcssparser.y"
                                           {
    (yyvsp[-1].rule)->setSelector((yyvsp[-3].selector));
    parser->addRule((yyvsp[-1].rule));
    (yyval.rule) = nullptr;
  }
#line 1652 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 5: /* Rule: Import  */
#line 152 "style/mapcssparser.y"
         { (yyval.rule) = nullptr; }
#line 1658 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 6: /* Import: T_KEYWORD_IMPORT T_KEYWORD_URL T_LPAREN T_STRING T_RPAREN T_SEMICOLON  */
#line 156 "style/mapcssparser.y"
                                                                        {
    if (!parser->addImport((yyvsp[-2].str))) {
        YYABORT;
    }
  }
#line 1668 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 7: /* Import: T_KEYWORD_IMPORT T_KEYWORD_URL T_LPAREN T_STRING T_RPAREN T_IDENT T_SEMICOLON  */
#line 161 "style/mapcssparser.y"
                                                                                { parser->addImport((yyvsp[-3].str)); }
#line 1674 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 8: /* Selectors: Selector  */
#line 165 "style/mapcssparser.y"
           { (yyval.selector) = (yyvsp[0].selector); }
#line 1680 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 9: /* Selectors: Selectors T_COMMA Selector  */
#line 166 "style/mapcssparser.y"
                             { if (auto u = dynamic_cast<MapCSSUnionSelector*>((yyvsp[-2].selector))) {
    u->selectors.push_back(std::unique_ptr<MapCSSSelector>((yyvsp[0].selector)));
    (yyval.selector) = (yyvsp[-2].selector);
  } else {
    auto s = new MapCSSUnionSelector;
    s->selectors.push_back(std::unique_ptr<MapCSSSelector>((yyvsp[-2].selector)));
    s->selectors.push_back(std::unique_ptr<MapCSSSelector>((yyvsp[0].selector)));
    (yyval.selector) = s;
  }}
#line 1694 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 10: /* Selector: BasicSelector  */
#line 178 "style/mapcssparser.y"
                { (yyval.selector) = (yyvsp[0].basicSelector); }
#line 1700 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 11: /* Selector: Selector BasicSelector  */
#line 179 "style/mapcssparser.y"
                         { if (auto chain = dynamic_cast<MapCSSChainedSelector*>((yyvsp[-1].selector))) {
    chain->selectors.push_back(std::unique_ptr<MapCSSBasicSelector>((yyvsp[0].basicSelector)));
    (yyval.selector) = (yyvsp[-1].selector);
  } else {
    auto s = new MapCSSChainedSelector;
    s->selectors.push_back(std::unique_ptr<MapCSSBasicSelector>(static_cast<MapCSSBasicSelector*>((yyvsp[-1].selector))));
    s->selectors.push_back(std::unique_ptr<MapCSSBasicSelector>((yyvsp[0].basicSelector)));
    (yyval.selector) = s;
  }}
#line 1714 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 12: /* BasicSelector: T_IDENT ClassSelector ZoomRange Tests  */
#line 192 "style/mapcssparser.y"
                                                    {
    (yyval.basicSelector) = new MapCSSBasicSelector;
    (yyval.basicSelector)->setClass((yyvsp[-2].strRef).str, (yyvsp[-2].strRef).len);
    (yyval.basicSelector)->setObjectType((yyvsp[-3].strRef).str, (yyvsp[-3].strRef).len);
    (yyval.basicSelector)->setZoomRange((yyvsp[-1].zoomRange).low, (yyvsp[-1].zoomRange).high);
    (yyval.basicSelector)->setConditions((yyvsp[0].conditionHolder));
  }
#line 1726 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 13: /* BasicSelector: T_STAR ClassSelector ZoomRange Tests  */
#line 199 "style/mapcssparser.y"
                                                {
    (yyval.basicSelector) = new MapCSSBasicSelector;
    (yyval.basicSelector)->objectType = MapCSSBasicSelector::Any;
    (yyval.basicSelector)->setClass((yyvsp[-2].strRef).str, (yyvsp[-2].strRef).len);
    (yyval.basicSelector)->setZoomRange((yyvsp[-1].zoomRange).low, (yyvsp[-1].zoomRange).high);
    (yyval.basicSelector)->setConditions((yyvsp[0].conditionHolder));
  }
#line 1738 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 14: /* ClassSelector: %empty  */
#line 209 "style/mapcssparser.y"
         { (yyval.strRef).str = nullptr; (yyval.strRef).len = 0; }
#line 1744 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 15: /* ClassSelector: T_DOT T_IDENT  */
#line 210 "style/mapcssparser.y"
                   { (yyval.strRef).str = (yyvsp[0].strRef).str; (yyval.strRef).len = (yyvsp[0].strRef).len; }
#line 1750 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 16: /* ZoomRange: %empty  */
#line 214 "style/mapcssparser.y"
         { (yyval.zoomRange).low = 0; (yyval.zoomRange).high = 0; }
#line 1756 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 17: /* ZoomRange: T_ZOOM T_DOUBLE T_DASH T_DOUBLE  */
#line 215 "style/mapcssparser.y"
                                             { (yyval.zoomRange).low = (yyvsp[-2].doubleVal); (yyval.zoomRange).high = (yyvsp[0].doubleVal); }
#line 1762 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 18: /* ZoomRange: T_ZOOM T_DOUBLE T_DASH  */
#line 216 "style/mapcssparser.y"
                              { (yyval.zoomRange).low = (yyvsp[-1].doubleVal); (yyval.zoomRange).high = 0; }
#line 1768 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 19: /* ZoomRange: T_ZOOM T_DOUBLE  */
#line 217 "style/mapcssparser.y"
                  { (yyval.zoomRange).low = (yyvsp[0].doubleVal); (yyval.zoomRange).high = (yyvsp[0].doubleVal); }
#line 1774 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 20: /* ZoomRange: T_ZOOM T_DASH T_DOUBLE  */
#line 218 "style/mapcssparser.y"
                               { (yyval.zoomRange).low = 0; (yyval.zoomRange).high = (yyvsp[0].doubleVal); }
#line 1780 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 21: /* Tests: %empty  */
#line 221 "style/mapcssparser.y"
         { (yyval.conditionHolder) = nullptr; }
#line 1786 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 22: /* Tests: Tests Test  */
#line 222 "style/mapcssparser.y"
             { if ((yyvsp[-1].conditionHolder)) { (yyvsp[-1].conditionHolder)->addCondition((yyvsp[0].condition)); (yyval.conditionHolder) = (yyvsp[-1].conditionHolder); } else { auto holder = new MapCSSConditionHolder; holder->addCondition((yyvsp[0].condition)); (yyval.conditionHolder) = holder; }}
#line 1792 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 23: /* Test: T_LBRACKET Condition T_RBRACKET  */
#line 225 "style/mapcssparser.y"
                                      { (yyval.condition) = (yyvsp[-1].condition); }
#line 1798 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 24: /* Condition: Key BinaryOp T_IDENT  */
#line 229 "style/mapcssparser.y"
                       { (yyval.condition) = new MapCSSCondition; (yyval.condition)->setKey((yyvsp[-2].strRef).str, (yyvsp[-2].strRef).len); (yyval.condition)->setOperation((yyvsp[-1].binaryOp)); (yyval.condition)->setValue((yyvsp[0].strRef).str, (yyvsp[0].strRef).len); }
#line 1804 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 25: /* Condition: Key BinaryOp DoubleValue  */
#line 230 "style/mapcssparser.y"
                           { (yyval.condition) = new MapCSSCondition; (yyval.condition)->setKey((yyvsp[-2].strRef).str, (yyvsp[-2].strRef).len); (yyval.condition)->setOperation((yyvsp[-1].binaryOp)); (yyval.condition)->setValue((yyvsp[0].doubleVal)); }
#line 1810 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 26: /* Condition: T_EXCLAMATION_MARK Key  */
#line 231 "style/mapcssparser.y"
                         { (yyval.condition) = new MapCSSCondition; (yyval.condition)->setOperation(MapCSSCondition::KeyNotSet); (yyval.condition)->setKey((yyvsp[0].strRef).str, (yyvsp[0].strRef).len); }
#line 1816 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 27: /* Condition: Key  */
#line 232 "style/mapcssparser.y"
      { (yyval.condition) = new MapCSSCondition; (yyval.condition)->setOperation(MapCSSCondition::KeySet); (yyval.condition)->setKey((yyvsp[0].strRef).str, (yyvsp[0].strRef).len); }
#line 1822 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 28: /* BinaryOp: T_BINARY_OP  */
#line 236 "style/mapcssparser.y"
              { (yyval.binaryOp) = (yyvsp[0].binaryOp); }
#line 1828 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 29: /* BinaryOp: T_EQUALS  */
#line 237 "style/mapcssparser.y"
              { (yyval.binaryOp) = MapCSSCondition::Equal; }
#line 1834 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 30: /* Key: T_IDENT  */
#line 240 "style/mapcssparser.y"
          { (yyval.strRef) = (yyvsp[0].strRef); }
#line 1840 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 31: /* Key: Key T_COLON T_IDENT  */
#line 241 "style/mapcssparser.y"
                      { (yyval.strRef).str = (yyvsp[-2].strRef).str; (yyval.strRef).len = (yyvsp[0].strRef).str - (yyvsp[-2].strRef).str + (yyvsp[0].strRef).len; }
#line 1846 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 32: /* Declarations: %empty  */
#line 245 "style/mapcssparser.y"
         { (yyval.rule) = new MapCSSRule; }
#line 1852 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 33: /* Declarations: Declarations Declaration  */
#line 246 "style/mapcssparser.y"
                           { (yyval.rule) = (yyvsp[-1].rule); (yyval.rule)->addDeclaration((yyvsp[0].declaration)); }
#line 1858 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 34: /* Declaration: PropertyName T_COLON PropertyValue T_SEMICOLON  */
#line 250 "style/mapcssparser.y"
                                                 { (yyval.declaration) = (yyvsp[-1].declaration); (yyval.declaration)->setPropertyName((yyvsp[-3].strRef).str, (yyvsp[-3].strRef).len); }
#line 1864 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 35: /* Declaration: T_KEYWORD_SET Key T_EQUALS T_STRING T_SEMICOLON  */
#line 251 "style/mapcssparser.y"
                                                        {
    (yyval.declaration) = new MapCSSDeclaration(MapCSSDeclaration::TagDeclaration);
    (yyval.declaration)->setIdentifierValue((yyvsp[-3].strRef).str, (yyvsp[-3].strRef).len);
    (yyval.declaration)->setStringValue((yyvsp[-1].str));
  }
#line 1874 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 36: /* Declaration: T_KEYWORD_SET Key T_EQUALS T_DOUBLE T_SEMICOLON  */
#line 256 "style/mapcssparser.y"
                                                        {
    (yyval.declaration) = new MapCSSDeclaration(MapCSSDeclaration::TagDeclaration);
    (yyval.declaration)->setIdentifierValue((yyvsp[-3].strRef).str, (yyvsp[-3].strRef).len);
    (yyval.declaration)->setDoubleValue((yyvsp[-1].doubleVal));
  }
#line 1884 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 37: /* Declaration: T_KEYWORD_SET Key T_SEMICOLON  */
#line 261 "style/mapcssparser.y"
                                   {
    (yyval.declaration) = new MapCSSDeclaration(MapCSSDeclaration::TagDeclaration);
    (yyval.declaration)->setIdentifierValue((yyvsp[-1].strRef).str, (yyvsp[-1].strRef).len);
  }
#line 1893 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 38: /* Declaration: T_KEYWORD_SET T_DOT T_IDENT T_SEMICOLON  */
#line 265 "style/mapcssparser.y"
                                             {
    (yyval.declaration) = new MapCSSDeclaration(MapCSSDeclaration::ClassDeclaration);
    (yyval.declaration)->setIdentifierValue((yyvsp[-1].strRef).str, (yyvsp[-1].strRef).len);
  }
#line 1902 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 39: /* PropertyName: T_IDENT  */
#line 272 "style/mapcssparser.y"
          { (yyval.strRef) = (yyvsp[0].strRef); }
#line 1908 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 40: /* PropertyName: T_IDENT T_DASH PropertyName  */
#line 273 "style/mapcssparser.y"
                              { (yyval.strRef).str = (yyvsp[-2].strRef).str; (yyval.strRef).len = (yyvsp[0].strRef).str - (yyvsp[-2].strRef).str + (yyvsp[0].strRef).len; }
#line 1914 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 41: /* PropertyValue: Key  */
#line 278 "style/mapcssparser.y"
      { (yyval.declaration) = new MapCSSDeclaration(MapCSSDeclaration::PropertyDeclaration); (yyval.declaration)->setIdentifierValue((yyvsp[0].strRef).str, (yyvsp[0].strRef).len); }
#line 1920 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 42: /* PropertyValue: T_HEX_COLOR  */
#line 279 "style/mapcssparser.y"
              { (yyval.declaration) = new MapCSSDeclaration(MapCSSDeclaration::PropertyDeclaration); (yyval.declaration)->setColorRgba((yyvsp[0].uintVal)); }
#line 1926 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 43: /* PropertyValue: DoubleValue T_IDENT  */
#line 280 "style/mapcssparser.y"
                      { (yyval.declaration) = new MapCSSDeclaration(MapCSSDeclaration::PropertyDeclaration); (yyval.declaration)->setDoubleValue((yyvsp[-1].doubleVal)); (yyval.declaration)->setUnit((yyvsp[0].strRef).str, (yyvsp[0].strRef).len); }
#line 1932 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 44: /* PropertyValue: DoubleValue  */
#line 281 "style/mapcssparser.y"
              { (yyval.declaration) = new MapCSSDeclaration(MapCSSDeclaration::PropertyDeclaration); (yyval.declaration)->setDoubleValue((yyvsp[0].doubleVal)); }
#line 1938 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 45: /* PropertyValue: T_DOUBLE T_COMMA T_DOUBLE  */
#line 282 "style/mapcssparser.y"
                            { (yyval.declaration) = new MapCSSDeclaration(MapCSSDeclaration::PropertyDeclaration); (yyval.declaration)->setDashesValue({(yyvsp[-2].doubleVal), (yyvsp[0].doubleVal)}); }
#line 1944 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 46: /* PropertyValue: T_STRING  */
#line 283 "style/mapcssparser.y"
           { (yyval.declaration) = new MapCSSDeclaration(MapCSSDeclaration::PropertyDeclaration); (yyval.declaration)->setStringValue((yyvsp[0].str)); }
#line 1950 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 47: /* PropertyValue: T_KEYWORD_RGBA T_LPAREN T_DOUBLE T_COMMA T_DOUBLE T_COMMA T_DOUBLE T_COMMA T_DOUBLE T_RPAREN  */
#line 284 "style/mapcssparser.y"
                                                                                                           {
    (yyval.declaration) = new MapCSSDeclaration(MapCSSDeclaration::PropertyDeclaration);
    uint32_t c = 0;
    c |= (uint32_t)((yyvsp[-1].doubleVal) * 255.0) << 24;
    c |= (uint32_t)((yyvsp[-7].doubleVal) * 255.0) << 16;
    c |= (uint32_t)((yyvsp[-5].doubleVal) * 255.0) << 8;
    c |= (uint32_t)((yyvsp[-3].doubleVal) * 255.0) << 0;
    (yyval.declaration)->setColorRgba(c);
  }
#line 1964 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 48: /* PropertyValue: T_KEYWORD_RGB T_LPAREN T_DOUBLE T_COMMA T_DOUBLE T_COMMA T_DOUBLE T_RPAREN  */
#line 293 "style/mapcssparser.y"
                                                                                      {
    (yyval.declaration) = new MapCSSDeclaration(MapCSSDeclaration::PropertyDeclaration);
    uint32_t c = 0;
    c |= 0xff << 24;
    c |= (uint32_t)((yyvsp[-5].doubleVal) * 255.0) << 16;
    c |= (uint32_t)((yyvsp[-3].doubleVal) * 255.0) << 8;
    c |= (uint32_t)((yyvsp[-1].doubleVal) * 255.0) << 0;
    (yyval.declaration)->setColorRgba(c);
  }
#line 1978 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 49: /* DoubleValue: T_DOUBLE  */
#line 305 "style/mapcssparser.y"
           { (yyval.doubleVal) = (yyvsp[0].doubleVal); }
#line 1984 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 50: /* DoubleValue: T_DASH T_DOUBLE  */
#line 306 "style/mapcssparser.y"
                  { (yyval.doubleVal) = -(yyvsp[0].doubleVal); }
#line 1990 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;

  case 51: /* DoubleValue: T_PLUS T_DOUBLE  */
#line 307 "style/mapcssparser.y"
                  { (yyval.doubleVal) = (yyvsp[0].doubleVal); }
#line 1996 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"
    break;


#line 2000 "/home/iurt/rpmbuild/BUILD/kosmindoormap-20.12.0/build/src/map/mapcssparser_p.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (&yylloc, parser, scanner, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, parser, scanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp, parser, scanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, parser, scanner, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, parser, scanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp, parser, scanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 310 "style/mapcssparser.y"

